import ConfigParser, sys, string, os.path

class hiConfig(object):
	def __init__ (self, fname):
		self.property = {}
		self.method = {}
		config = ConfigParser.ConfigParser()
		config.optionxform=str
		config.read(fname)
		
		for name in config.options('Property'):
			val = config.get('Property',name)
			if not (name[0] in string.ascii_letters):
				name = name[1:]
			p = Property(name+'='+val)
			self.property[name] = p
		
		for name in config.options('Methods'):
			val = config.get('Methods',name)
			if not (name[0] in string.ascii_letters):
				name = name[1:]
			m = Method(name+'='+val, self)
			self.method[name] = m
			
		(fp, fn) = os.path.split(fname)
		fp = fp.replace('conf', 'code')
		fn = 'hi'+fn.replace('ini', 'hws')
		oname = os.path.join(fp, fn)

		ofile = open(oname, 'w')
		
		ofile.write('func init\n')
		for k,p in self.property.iteritems():			
			code = p.to_code()
			for l in code.split("\n"):
				if (l != ""):
					ofile.write("\t"+l+"\n")
		ofile.write('end\n\n')
		
		for k,m in self.method.iteritems():
			ofile.write(m.to_code())
		ofile.close()

class Property(object):
	def __init__(self, str):
		self.name = str.split('=',1)[0]
		if not (self.name[0] in string.ascii_letters):
			self.name = self.name[1:]

		value = str.split('=',1)[1]
		value.replace('||', '@@')
		if (len(value.split('|')) == 3): 
			(self.desc, ptype, self.val) = value.split('|')
			self.vallist = None
		else:
			(self.desc, ptype, self.val, val_list) = value.split('|')
			self.vallist = map(lambda x:x.strip(), val_list.split(","))
		self.desc.replace('@@', '||')
		self.ptype = int(ptype)
		
	def to_code(self):
		print "To code for prop "+self.name+" of type "+str(self.ptype)
		if (self.ptype == 0):
			return ""
		
		if (self.ptype == 1) or (self.ptype == 2) or (self.ptype == 7):
			return ('sys.set_undef_field("'+self.name+'")')
		
		if (self.ptype == 4) or (self.ptype == 14):
			if len(self.vallist) == 2:
				if (self.vallist[0].lower() == 'true' and self.vallist[1].lower() == 'false') or (self.vallist[0].lower() == 'false' and self.vallist[1].lower() == 'true'):
					return ('sys.set_undef_field_bool("'+self.name+'")\n')
				else:
					return ('sys.set_field("'+self.name+'")\n')
					
		if (self.ptype == 5):
			code = "//TODO:Config: change type of "+self.name+" to str\n"
			code += "blk_init.println(this.codename+'.Items.AddRange('+this.props(\""+self.name+"\").value+'.Split(new char[]"+r"{\'\x0D\', \'\x0A\'}"+", StringSplitOptions.RemoveEmptyEntries));')\n"
			return code
			
		return ""
					
class Method(object):
	def __init__(self, str, c):
		self.sname = str.split('=',1)[0]
		value = str.split('=',1)[1]
		value.replace('||', '@@')
		(self.desc, ptype, self.rtype) = value.split('|')
		self.desc.replace('@@', '||')
		self.ptype = int(ptype)
		self.config = c
		
	def to_code(self):
		if (self.ptype == 2) or (self.ptype == 4):
			return ""
		
		if (self.sname.find('%')!=-1):
			(self.name, prop_name, tmp) = self.sname.split('%')
			prop = self.config.property[prop_name]
			code = 'func '+self.name+'(data):\n'
			for i in range(len(prop.vallist)):
				code_if = '\tif (this.props("'+prop_name+'").value == '+str(i)+')\n'
				if (self.ptype==4):
					s_ret = "return "
				else:
					s_ret = ""
				
				code_if+= '\t\t'+s_ret+self.name+str(i)+'(data)\n'
				code += code_if
			
			code += '\n\n'
			for i in range(len(prop.vallist)):
				code += 'func '+self.name+str(i)+'(data)\n\treturn\nend\n\n'
				
		else:
			self.name = self.sname
			code = 'func '+self.name+'(data)\n\treturn\nend\n\n'
		
		return code
		
	
def main():
	cf = hiConfig(sys.argv[1])
	
if __name__ == '__main__':
	main()